[![KendoReact NPM Banner](https://raw.githubusercontent.com/telerik/kendo-react/master/images/kendoreact-github-banner.png)](https://www.telerik.com/kendo-react-ui/components/free?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs&utm_content=banner)

# KendoReact Inputs Library for React

> **Important**
>
> -   This package is а part of [KendoReact](https://www.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)&mdash;an enterprise-grade UI library with 120+ free and premium components.
> -   It contains both free and premium KendoReact components and tools. To use the premium components, you will need to [purchase a license](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) or register for a [free trial](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs). You can use the free components without having to sign up or get a license key.
> -   If you're looking for free React components, check out [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free).
> -   If you have an active license, visit the [KendoReact My License page](https://www.telerik.com/kendo-react-ui/components/my-license/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) to learn how to configure your KendoReact licensing.
> -   Installing and working with this package indicates that you [accept the KendoReact License Agreement](https://www.telerik.com/purchase/license-agreement/progress-kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs).
> -   The 30-day free trial gives you access to all KendoReact components and their full functionality. Additionally, for the period of your trial, you can use our legendary technical support provided directly by the KendoReact dev team!
>
> [Start using KendoReact](https://www.telerik.com/try/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) and speed up your development process!

The React Inputs, part of KendoReact, offer a highly customizable interface for users to enter and pick different information. The KendoReact Inputs support different locales and formats.

How to start:

```sh
npm i @progress/kendo-react-inputs
```

What's in this package (ToC):

-   [React Inputs Components Library Features](#react-inputs-components-library-features)
-   [React Checkbox Component (free)](#react-checkbox-component)
-   [React ColorGradient Component (premium)](#react-colorgradient-component)
-   [React ColorPalette Component (free)](#react-colorpalette-component)
-   [React ColorPicker Component (premium)](#react-colorpicker-component)
-   [React FlatColorPicker Component (premium)](#react-colorpicker-component)
-   [React Input Component (free)](#react-input-component)
-   [React MaskedTextBox Component (free)](#react-maskedtextbox-component)
-   [React NumericTextBox Component (free)](#react-numerictextbox-component)
-   [React RadioButton Component (free)](#react-radiobutton-component)
-   [React RadioGroup Component (free)](#react-radiobuttongroup-component)
-   [React RangeSlider Component (premium)](#react-rangeslider-component)
-   [React Rating Component (free)](#react-rating-component)
-   [React Signature Component (premium)](#react-signature-component)
-   [React Slider Component (free)](#react-slider-component)
-   [React Switch Component (free)](#react-switch-component)
-   [React TextArea Component (free)](#react-textarea-component)
-   [React TextBox Component (free)](#react-textbox-component)

Additional information:

-   [Support Options](#support-options)
-   [Resources](#resources)
-   [KendoReact Inputs API](#kendo-react-inputs-api)

## React Inputs Components Library Features

Among the many features which the KendoReact Inputs deliver are:

-   **Labels**&mdash;To make implementing the KendoReact Inputs as easy as possible, the React UI components come with a built-in Label property, which can be placed before or after the actual element. For scenarios where the built-in label is not suitable, a custom label can be easily applied.
-   **Setting the default value**&mdash;Easily configure the initial value that the Inputs render.
-   **Form validation**&mdash;Validate input values, set validation requirements (such as minimum and maximum) and prevent the submission of forms which are in an invalid state.
-   **Formats and placeholders**&mdash;Control the placeholders for the input field, including custom formats.
-   **Controlled state**&mdash;Control the value Inputs.
-   **Accessibility support**&mdash;The Inputs are compliant with WAI-ARIA and Section 508.
-   [Theme support](https://www.telerik.com/kendo-react-ui/components/styling/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)&mdash;The KendoReact Inputs, as well as all 100+ components in the KendoReact suite, are styled in three polished themes (Bootstrap, Material, and Default) and can be further customized to match your specific design guidelines.
-   [Unstyled mode](https://www.telerik.com/kendo-react-ui/components/unstyled)&mdash;The KendoReact Inputs support an unstyled mode, offering complete control over the popup appearance.

## React Checkbox Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Checkbox component](https://www.telerik.com/kendo-react-ui/checkbox?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) moves beyond the traditional HTML input element and provides styling that fits with all KendoReact themes, allowing users to maintain a consistent look and feel throughout their entire React application.

How to use the Checkbox component in your apps:

```tsx
import { Checkbox } from '@progress/kendo-react-inputs';
...
<Checkbox label="Checkbox label" />
```

## React ColorGradient Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The KendoReact ColorGradient component](https://www.telerik.com/kendo-react-ui/colorgradient?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) provides a beautiful and easy-to-use user interface for choosing a gradient color. In some cases, the opacity of the gradient is not required, and you can remove the opacity input to make the component more compact.

How to use the ColorGradient component in your apps:

```tsx
import { ColorGradient } from '@progress/kendo-react-inputs';
...
<ColorGradient />
```

## React ColorPalette Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact ColorPalette component](https://www.telerik.com/kendo-react-ui/colorpalette?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) can render all colors and color presets, making it ideal when we have to present the user with all available color options. Rendering a specific color preset is available out of the box. This can save time and code by enabling developers to set just the name of the color preset instead of setting each color individually.

How to use the ColorPalette component in your apps:

```tsx
import { ColorPalette } from '@progress/kendo-react-inputs';
...
<ColorPalette palette="basic" />
```

## React ColorPicker Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The KendoReact ColorPicker component](https://www.telerik.com/kendo-react-ui/colorpicker?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) provides users with an intuitive way of selecting and submitting color values. The KendoReact ColorPicker allows users to pick colors from either a color gradient, which provides an interactive way to select a color by dragging a pointer around a gradient, or a color palette which contains predefined colors in a palette. Primarily serving accessibility enablement, the KendoReact ColorPicker will display the current contrast ratio and indicate whether the contrast color is compliant with an AA or AAA contrast ratio.

How to use the ColorPicker component in your apps:

```tsx
import { ColorPicker } from '@progress/kendo-react-inputs';
...
<ColorPicker views={['gradient', 'palette']} /> // Shows both views of the ColorPicker and end users can switch between the two.
```

## React FlatColorPicker Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The KendoReact FlatColorPicker component](https://www.telerik.com/kendo-react-ui/flatcolorpicker?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) adds another option for your users to select colors in React applications. It provides a flat view for the React ColorGradient and the React ColorPalette components and adds a header and footer. Unlike the React ColorPicker component, the React FlatColorPicker is not rendered within a popup or dropdown but immediately to the page.

How to use the FlatColorPicker component in your apps:

```tsx
import { FlatColorPicker } from '@progress/kendo-react-inputs';
...
<FlatColorPicker views={['gradient', 'palette']} /> // Shows both views of the FlatColorPicker and end users can switch between the two.
```

## React Input Component

> This is a **free React component**&mdash;no sign-up or license required.

[The React Input](https://www.telerik.com/kendo-react-ui/input?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) component builds on top of a traditional HTML input element and provides additional KendoReact styling to fit with all KendoReact themes, as well as the ability to provide a label as a floating label.

How to use the Input component in your apps:

```tsx
import { Input } from '@progress/kendo-react-inputs';
...
<Input label={'Floating label for the input field'}/>
```

## React MaskedTextBox Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact MaskedTextBox component](https://www.telerik.com/kendo-react-ui/maskedtextbox?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) provide built-in masks to not only indicate to the user what kind of format is expected, but can also enforce this mask as the user is inserting data, then validate data when a form is submitted. The React MaskedTextBox supports a set of built-in masks like requiring digits, letters or special symbols and characters, but custom rules can be applied as well.

How to use the MaskedTextBox component in your apps:

```tsx
import { MaskedTextBox } from '@progress/kendo-react-inputs';
...
<MaskedTextBox
    mask="(999) 000-00-00-00" // Sets a phone number mask with a country prefix.
/>
```

## React NumericTextBox Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact NumericTextBox component](https://www.telerik.com/kendo-react-ui/numerictextbox?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) allows end users to input or adjust numeric values via typing or spin buttons.

How to use the NumericTextBox component in your apps:

```tsx
import { NumericTextBox } from '@progress/kendo-react-inputs';
...
<NumericTextBox />
```

## React RadioButton Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact RadioButton component](https://www.telerik.com/kendo-react-ui/radiobutton?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) allows developers to style React RadioButtons to fit the existing KendoReact theme and have a uniform look and feel throughout their entire application.

How to use the RadioButton component in your apps:

```tsx
import { RadioButton } from '@progress/kendo-react-inputs';
...
<RadioButton label="RadioButton Label" />
```

## React RadioGroup Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact RadioGroup](https://www.telerik.com/kendo-react-ui/radiogroup?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) is a component that is used when two or more options need to be available from a RadioButton. Toggling between horizontal and vertical layouts for the KendoReact RadionGroup component can be done by interacting with a single property.

How to use the RadioGroup component in your apps:

```tsx
import { RadioGroup } from '@progress/kendo-react-inputs';
...
/**
* Provide an array of items for the radio buttons within the group.
*/
<RadioGroup data={data} />
```

## React RangeSlider Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The KendoReact RangeSlider component](https://www.telerik.com/kendo-react-ui/rangeslider?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) enables end users to increase, decrease and select a predefined range of values by dragging left and right handles along a track. The React RangeSlider component has a single configuration option to help set the orientation to either vertical or horizontal orientations.

How to use the RadioGroup component in your apps:

```tsx
import { RangeSlider, SliderLabel } from '@progress/kendo-react-inputs';
...
<RangeSlider
  defaultValue={{ start: 30, end: 70 }}
  step={1}
  min={0}
  max={100}
>
  {[0, 25, 50, 75, 100].map((perc, i) => (
    <SliderLabel
      key={i}
      position={perc}
    >
      {perc.toString()}
    </SliderLabel>
  ))}
</RangeSlider>
```

## React Rating Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Rating component](https://www.telerik.com/kendo-react-ui/rating?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) lets end users provide visual ratings in React apps. The component supports partial ratings (for example, 4.5 stars) and integrates with other UI components like the KendoReact Data Grid.

How to use the Rating component in your apps:

```tsx
import { Rating } from '@progress/kendo-react-inputs';
...
<Rating />
```

## React Signature Component

> This is a KendoReact **premium component** and requires a commercial license or an active trial license.

[The KendoReact Signature component](https://www.telerik.com/kendo-react-ui/signature?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) captures handwritten signatures via mouse or touch and submits them in forms, making it ideal for signing documents like financial forms or receipts.

How to use the Signature component in your apps:

```tsx
import { Signature } from '@progress/kendo-react-inputs';
...
<Signature />
```

## React Slider Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact Slider component](https://www.telerik.com/kendo-react-ui/slider?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) provides a sleek and intuitive UI interface for increasing, decreasing and selecting predefined values by dragging a handle along a track, or selecting a value by utilizing the provided side arrow buttons. Out of the box, the KendoReact Slider can render itself in both horizontal or vertical modes. Switching between the two is as simple as updating a single configuration option.

How to use the Slider component in your apps:

```tsx
import { Slider } from '@progress/kendo-react-inputs';
...
<Slider
  step={1}
  min={1}
  max={10}
>
```

## React Switch Component

Popularized by iOS, Android, and other mobile operating systems, [the KendoReact Switch component](https://www.telerik.com/kendo-react-ui/switch?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) lets users toggle between two values: often checked and unchecked states.

How to use the Slider component in your apps:

```tsx
import { Switch } from '@progress/kendo-react-inputs';
...
<Switch />
```

## React TextArea Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact TextArea component](https://www.telerik.com/kendo-react-ui/textarea?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) is suitable for any scenario that requires multiple lines of text. The TextArea (also known as Multi-line TextBox) component comes with a built-in character counter, which gives end-users a real-time indication of the number of characters currently typed. The dimensions of the React TextArea component can be defined in multiple ways. This includes setting the initial height of the TextArea component and controlling if the component should automatically resize based on the content entered by the user.

How to use the TextArea component in your apps:

```tsx
import { TextArea } from '@progress/kendo-react-inputs';
...
<TextArea />
```

## React TextBox Component

> This is a **free React component**&mdash;no sign-up or license required.

[The KendoReact TextBox component](https://www.telerik.com/kendo-react-ui/components/inputs/textbox?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) is a versatile and more refined alternative to the Input, providing multiple additional props.

How to use the TextBox component in your apps:

```tsx
import { TextBox } from '@progress/kendo-react-inputs';
...
<TextBox />
```

## Support Options

For any issues you might encounter while working with the KendoReact Inputs, use any of the available support channels:

-   Industry-leading technical support&mdash;KendoReact paid license holders and users with an active (free) trial license can take advantage of our outstanding customer support. To submit a ticket, use [the dedicated KendoReact support system](https://www.telerik.com/account/support-center/contact-us/technical-support?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs).
-   Product forums&mdash;The [KendoReact forums](https://www.telerik.com/forums/kendo-ui-react?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) are part of the free support you can get from the community and from the KendoReact team.
-   Feedback portal&mdash;The [KendoReact feedback portal](https://feedback.telerik.com/kendo-react-ui?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs) is where you can request and vote for new features to be added.

## Resources

-   [Getting Started with KendoReact](https://www.telerik.com/kendo-react-ui/components/getting-started/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [Get Started with KendoReact Free](https://www.telerik.com/kendo-react-ui/components/free)
-   [Getting Started with the KendoReact Inputs](https://www.telerik.com/kendo-react-ui/components/inputs/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [API Reference of the KendoReact Inputs](https://www.telerik.com/kendo-react-ui/components/inputs/api/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [KendoReact Roadmap](https://www.telerik.com/support/whats-new/kendo-react-ui/roadmap?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [Blogs](https://www.telerik.com/blogs/tag/kendoreact?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [Demos, documentation, and component reference](https://www.telerik.com/kendo-react-ui/components/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [KendoReact pricing and licensing](https://www.telerik.com/kendo-react-ui/pricing?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)
-   [Changelog](https://www.telerik.com/kendo-react-ui/components/changelogs/ui-for-react/?utm_medium=referral&utm_source=npm&utm_campaign=kendo-ui-react-trial-npm-inputs)

High-level component overview pages

-   [React Checkbox Component](https://www.telerik.com/kendo-react-ui/checkbox)
-   [React ColorGradient Component](https://www.telerik.com/kendo-react-ui/colorgradient)
-   [React ColorPalette Component](https://www.telerik.com/kendo-react-ui/colorpalette)
-   [React ColorPicker Component](https://www.telerik.com/kendo-react-ui/colorpicker)
-   [React FlatColorPicker Component](https://www.telerik.com/kendo-react-ui/flatcolorpicker)
-   [React Input Component](https://www.telerik.com/kendo-react-ui/input)
-   [React MaskedTextBox Component](https://www.telerik.com/kendo-react-ui/maskedtextbox)
-   [React NumericTextBox Component](https://www.telerik.com/kendo-react-ui/numerictextbox)
-   [React RadioButton Component](https://www.telerik.com/kendo-react-ui/radiobutton)
-   [React RadioGroup Component](https://www.telerik.com/kendo-react-ui/radiogroup)
-   [React RangeSlider Component](https://www.telerik.com/kendo-react-ui/rangeslider)
-   [React Rating Component](https://www.telerik.com/kendo-react-ui/rating)
-   [React Signature Component](https://www.telerik.com/kendo-react-ui/signature)
-   [React Slider Component](https://www.telerik.com/kendo-react-ui/slider)
-   [React Switch Component](https://www.telerik.com/kendo-react-ui/switch)
-   [React TextArea Component](https://www.telerik.com/kendo-react-ui/textarea)

_Copyright © 2025 Progress Software Corporation and/or its subsidiaries or affiliates. All Rights Reserved._

_Progress, Telerik, and certain product names used herein are trademarks or registered trademarks of Progress Software Corporation and/or one of its subsidiaries or affiliates in the U.S. and/or other countries._
